#!/usr/bin/env python

# based off of matchtemp.py from R0SSAR00
# at http://www.r0ssar00.com/2009/03/geektool.html
# i really only used the re command from him, everything else is my own.

# module imports
import re, shlex, subprocess

# get our command line argument in a list for
# modify based on your system and where you put smc.custom
path = "/Users/bobw/bin/geektool/"
cmd1 = path+"smc.custom -k TC0D -r"
cmd2 = path+"cpuusage"
cmd3 = path+"smc.custom -f | grep :::"
cmd1 = shlex.split(cmd1)
cmd3 = shlex.split(cmd3)

# get the data from the commands we want to run
smcdata1 = subprocess.Popen(cmd1, stdout=subprocess.PIPE).communicate()[0]
cpupcnt = subprocess.Popen(cmd2, stdout=subprocess.PIPE).communicate()[0].split()[0]
smcdata2a = subprocess.Popen(cmd3, stdout=subprocess.PIPE)
smcdata2b = subprocess.Popen(["grep",":::"], stdin=smcdata2a.stdout, stdout=subprocess.PIPE).communicate()[0]

# regex to parse the output of the first smc.custom command
match = re.search(r".*:::(\d*):::", smcdata1)
if match:
	cputemp = match.group(1)
else:
	cputemp = ""

# regext to figure out the output of the second smc.custom command
match = re.search(r"....(....).", smcdata2b)
if match:
	fanrpm = match.group(1)
else:
	fanrpm = ""

# figure out smile based on cpu temp
if int(cputemp) <= 120:
	smile = ":D"
elif int(cputemp) > 120 and cputemp <= 130:
	smile = ":P"
elif int(cputemp) > 130 and cputemp <= 140:
	smile = ":)"
elif int(cputemp) > 140 and cputemp <= 150:
	smile = ":|"
elif int(cputemp) > 150 and cputemp <= 160:
	smile = ":\\"
elif int(cputemp) > 160 and cputemp <= 170:
	smile = ":("
elif int(cputemp) > 170 and cputemp <= 180:
	smile = ":'("
elif int(cputemp) > 180 and cputemp <= 190:
	smile = ">:["
elif int(cputemp) > 190 and cputemp <= 200:
	smile = "X["
elif int(cputemp) > 200:
	smile = "HOSED"

# print the data
# customizable!
print "CPU: "+cpupcnt+" @ "+cputemp+"C "
print "FAN: "+fanrpm+" RPM"
